Index: branches/autoquest-core-tasktrees-alignment/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/GenerateTask.java
===================================================================
--- branches/autoquest-core-tasktrees-alignment/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/GenerateTask.java	(revision 1665)
+++ 	(revision )
@@ -1,43 +1,0 @@
-package de.ugoe.cs.autoquest.tasktrees.alignment.algorithms;
-
-/*
-import de.ugoe.cs.autoquest.tasktrees.treeifc.IIteration;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.IOptional;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ISequence;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskBuilder;
-import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskFactory;
-*/
-public class GenerateTask {
-	
-	
-	//private ITaskFactory taskFactory;
-	/**
-	 * <p>
-	 * the task builder to be used for creating substructures for the temporal
-	 * relationships identified during rule application
-	 * </p>
-	 */
-	/*
-	private ITaskBuilder taskBuilder;
-	
-	void sequence() {
-		ISequence sequence = taskFactory.createNewSequence();
-		//taskBuilder.addChild(sequence,ITask);
-		
-	}
-	
-	
-	void iteration() {
-		IIteration iteration = taskFactory.createNewIteration();
-		//taskBuilder.setMarkedTask(iteration, child);
-	}
-	
-	void optional() {
-		IOptional optional = taskFactory.createNewOptional();
-		//taskBuilder.setChild(optional, child);
-		
-	}
-	
-	*/
-	
-}
Index: branches/autoquest-core-tasktrees-alignment/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/MatchOccurence.java
===================================================================
--- branches/autoquest-core-tasktrees-alignment/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/MatchOccurence.java	(revision 1665)
+++ branches/autoquest-core-tasktrees-alignment/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/algorithms/MatchOccurence.java	(revision 1667)
@@ -20,5 +20,4 @@
 	}
 
-
 	public int getStartindex() {
 		return startindex;
Index: branches/autoquest-core-tasktrees-alignment/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/PairwiseAlignmentGenerator.java
===================================================================
--- branches/autoquest-core-tasktrees-alignment/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/PairwiseAlignmentGenerator.java	(revision 1665)
+++ branches/autoquest-core-tasktrees-alignment/src/main/java/de/ugoe/cs/autoquest/tasktrees/alignment/matrix/PairwiseAlignmentGenerator.java	(revision 1667)
@@ -31,45 +31,4 @@
 							smithWatermanThreshold);
 					alignments.set(i, j, aa);
-					//TODO: This is old code used for generating pairwise distances between alignments (to build
-					// a guide tree
-					/*
-					AlignmentAlgorithm sameSequence1 = AlignmentAlgorithmFactory
-							.create();
-					sameSequence1.align(ns1, ns1,
-							submat, smithWatermanThreshold);
-					AlignmentAlgorithm sameSequence2 = AlignmentAlgorithmFactory
-							.create();
-					sameSequence2.align(ns2, ns2,
-							submat, smithWatermanThreshold);
-					AlignmentAlgorithm randomSequence = AlignmentAlgorithmFactory
-							.create();
-					randomSequence.align(ns1.shuffle(), ns2
-							.shuffle(), submat,
-							smithWatermanThreshold);
-					
-					// Score of the aligmnment
-					double score = alignments.get(i, j).getAlignmentScore();
-
-					
-					// Scores of the sequence being aligned to itself (maximum
-					// score)
-					double sSelf1 = sameSequence1.getAlignmentScore();
-					double sSelf2 = sameSequence2.getAlignmentScore();
-					// Score of sequences shuffled before aligned
-					double sRand = randomSequence.getAlignmentScore();
-
-					double sMax = (sSelf1 + sSelf2) / 2;
-					double sEff = (score - sRand) / (sMax - sRand);
-					if (sEff < 0) {
-						sEff = 0;
-					}
-					double distance = -Math.log(sEff);
-
-					if (!Double.isInfinite(distance) && !Double.isNaN(distance)) {
-						if (distance < alignments.getDistance(i, j)) {
-							alignments.setDistance(i, j, distance);
-						}
-					}
-					*/
 				}
 			}